package org.processmining.traceclustering.connections;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.traceclustering.models.AbstractCaseClustering;

/**
 * Connection for the traceclustering of an event log using a set of parameters
 * 
 * @author B.F.A. Hompes
 *
 */
public class CaseClusteringConnection extends AbstractConnection {

	public final static String LOG = "XLog";
	public final static String CASECLUSTERING = "CaseClustering";

	public CaseClusteringConnection(XLog log, AbstractCaseClustering clustering) {
		super("Case clustering" + " on log " + XConceptExtension.instance().extractName(log)
				+ " using set parameters and perspectives.");

		put(LOG, log);
		put(CASECLUSTERING, clustering);
	}

	@Override
	public boolean equals(Object object) {
		if (!(object instanceof CaseClusteringConnection))
			return false;

		CaseClusteringConnection connection = (CaseClusteringConnection) object;

		if (!get(LOG).equals(connection.get(LOG)))
			return false;

		if (!get(CASECLUSTERING).equals(connection.get(CASECLUSTERING)))
			return false;

		return true;
	}
}