package org.processmining.traceclustering.models.impl;

import java.util.HashSet;

/**
 * Class that holds case ids in a set, i.e. a case cluster.
 * 
 * @author B.F.A. Hompes <b.f.a.hompes@tue.nl>
 *
 */
public class CaseCluster extends HashSet<Integer> {

	private static final long serialVersionUID = -2496169958102349099L;

	// Annotations for this cluster
	private CaseClusterAnnotation annotation;

	public CaseCluster() {
		setAnnotation(new CaseClusterAnnotation());
	}

	public CaseClusterAnnotation getAnnotation() {
		return annotation;
	}

	public void setAnnotation(CaseClusterAnnotation annotation) {
		this.annotation = annotation;
	}
}