package org.processmining.traceclustering.models.impl;

import java.util.Date;

import org.deckfour.xes.extension.std.XTimeExtension;
import org.deckfour.xes.model.XLog;

public class TimeWindow {

	private Date startDateTime;
	private Date endDateTime;

	public TimeWindow() {
	}

	public TimeWindow(Date start, Date end) {
		startDateTime = new Date(start.getTime());
		endDateTime = new Date(end.getTime());
	}

	public Date getStartDateTime() {
		return startDateTime;
	}

	public void setStartDateTime(Date startDateTime) {
		this.startDateTime = startDateTime;
	}

	public Date getEndDateTime() {
		return endDateTime;
	}

	public void setEndDateTime(Date endDateTime) {
		this.endDateTime = endDateTime;
	}

	// Only keep events that are known at endDateTime
	public XLog projectLogToWindow(XLog log) {
		XLog projectedLog = (XLog) log.clone();
		for (int t = 0; t < log.size(); t++) {
			trace: for (int e = 0; e < log.get(t).size(); e++) {
				if (XTimeExtension.instance().extractTimestamp(log.get(t).get(e)).compareTo(endDateTime) > 0) {
					if (e != 0)
						projectedLog.get(t).retainAll(projectedLog.get(t).subList(0, e - 1));
					break trace;
				}
			}
		}
		return projectedLog;
	}

	@Override
	public String toString() {
		return "Start: " + startDateTime.toString() + "\nEnd: " + endDateTime.toString();
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof TimeWindow))
			return false;

		TimeWindow w = (TimeWindow) obj;

		return startDateTime.equals(w.startDateTime) && endDateTime.equals(w.endDateTime);
	}
}
