package org.processmining.traceclustering.parameters.impl;

import org.processmining.traceclustering.models.impl.TimeWindowType;

public class TimeWindowParameters {

	private static TimeWindowType DEFAULTTYPE = TimeWindowType.NUMBEROFEVENTS;
	private static int DEFAULTWINDOWSIZE = 10;

	private TimeWindowType type;
	private int windowSize;

	public TimeWindowParameters() {
		this(DEFAULTTYPE, DEFAULTWINDOWSIZE);
	}

	public TimeWindowParameters(TimeWindowParameters param) {
		this(param.getType(), param.getWindowSize());
	}

	public TimeWindowParameters(TimeWindowType type, int windowSize) {
		setType(type);
		setWindowSize(windowSize);
	}

	public TimeWindowType getType() {
		return type;
	}

	public void setType(TimeWindowType type) {
		this.type = type;
	}

	public int getWindowSize() {
		return windowSize;
	}

	public void setWindowSize(int windowSize) {
		this.windowSize = windowSize;
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof TimeWindowParameters))
			return false;

		TimeWindowParameters param = (TimeWindowParameters) obj;

		if (!(param.getType().equals(getType()) && param.getWindowSize() == getWindowSize()))
			return false;

		return true;
	}

}
