package org.processmining.traceclustering.test.plugins;

import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginCategory;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(
		name = "TEST - make procedure trace attribute",
		parameterLabels = { "Event log" },
		returnLabels = { "Log" },
		returnTypes = { XLog.class },
		categories = { PluginCategory.Analytics })
public class MakeProcedureTraceAttributePlugin {

	@UITopiaVariant(
			affiliation = UITopiaVariant.EHV,
			author = "B.F.A. Hompes",
			email = "b.f.a.hompes@tue.nl")
	@PluginVariant(
			variantLabel = "TEST - make procedure trace attribute",
			requiredParameterLabels = { 0 })
	public Object doClusteringPublic(UIPluginContext context, XLog eventlog) {

		return go(context, eventlog);

	}

	private Object go(UIPluginContext context, XLog eventlog) {
		XLog newLog = (XLog) eventlog.clone();

		trace: for (XTrace trace : eventlog) {
			for (XEvent event : trace) {
				XAttribute procedure = event.getAttributes().get("procedure");
				if (procedure == null)
					continue;
				if (!procedure.toString().equals("")) {
					trace.getAttributes().put("procedure", procedure);
					continue trace;
				}
			}
		}

		return newLog;
	}

}