package org.processmining.traceclustering.visualization;

import java.awt.FlowLayout;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

/**
 * Very straight forward visualizer for all Number extended types. Creates a
 * JLabel with the result of the number's ".toString()" value in it.
 * 
 * @author B.F.A. Hompes <b.f.a.hompes@tue.nl>
 *
 */
@Plugin(
		name = "Visualize a number",
		returnLabels = { "Visualized number" },
		returnTypes = { JComponent.class },
		parameterLabels = { "A number" },
		userAccessible = false)
@Visualizer
public class NumberVisualisation {

	@PluginVariant(
			requiredParameterLabels = { 0 })
	public JComponent visualize(UIPluginContext context, Number number) {
		JLabel label = new JLabel(number.toString());
		JPanel panel = new JPanel();
		panel.add(label, FlowLayout.LEFT);
		return panel;
	}

}