package org.processmining.traceclustering.visualization.transformers;

import org.apache.commons.collections15.Transformer;
import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.model.XTrace;

/**
 * Transformer for vertex labels in the graph. Show trace name.
 * 
 * @author B.F.A. Hompes <b.f.a.hompes@tue.nl>
 *
 */
public class VertexLabelTransformer implements Transformer<Object, String> {

	@Override
	public String transform(Object object) {
		if (object instanceof XTrace)
			return XConceptExtension.instance().extractName((XTrace) object);
		else
			return "";
	}

}
