package org.processmining.traceclustering.visualization.transformers;

import java.awt.Shape;

import org.processmining.traceclustering.models.impl.CaseCluster;

import edu.uci.ics.jung.visualization.decorators.EllipseVertexShapeTransformer;

/**
 * Transformer for the shape of vertices in the graph.
 * 
 * @author B.F.A. Hompes <b.f.a.hompes@tue.nl>
 *
 * @param <V>
 */
public class VertexShapeTransformer<V> extends EllipseVertexShapeTransformer<V> {

	// If true: Give as many edges to polygon as there are traces in the cluster, with a maximum of maxSides.
	private static boolean polygonEdges = false;
	private static int maxSides = 5;

	public VertexShapeTransformer() {
		setSizeTransformer(new VertexSizeTransformer<V>(20));
	}

	@Override
	public Shape transform(V v) {
		if (v instanceof CaseCluster && polygonEdges) {
			int size = ((CaseCluster) v).size();
			return factory.getRegularPolygon(v, Math.max(size, maxSides));
		}
		return super.transform(v);
	}
}