package org.processmining.traceclustering.visualization.transformers;

import org.processmining.traceclustering.models.impl.CaseCluster;

import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.visualization.decorators.ToStringLabeller;

/**
 * Transformer for vertex tooltips in the graph.
 * 
 * @author B.F.A. Hompes <b.f.a.hompes@tue.nl>
 *
 */
@SuppressWarnings("rawtypes")
public class VertexToolTipTransformer extends ToStringLabeller {

	@SuppressWarnings("unchecked")
	@Override
	public String transform(Object v) {
		if (v instanceof Graph) {
			return ((Graph) v).getVertices().toString();
		}
		if (v instanceof CaseCluster) {
			CaseCluster cluster = (CaseCluster) v;
			String description = "<html>";
			description += "Size: " + cluster.size() + "<br/>";

			for (org.processmining.traceclustering.models.perspectives.AbstractPerspective dimension : cluster
					.getAnnotation().keySet()) {
				description += dimension.getDescription() + ": " + cluster.getAnnotation().get(dimension).toString()
						+ "<br/>";
			}

			description += "</html>";

			return description;
		}
		return super.transform(v);
	}
}